// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI64C200K/24DSI64C200K_linux_1.x_gsc_dn/driver/24dsi64c200k.h $
// $Rev: 52095 $
// $Date: 2022-12-01 10:53:33 -0600 (Thu, 01 Dec 2022) $

// 24DSI64C200K: Device Driver: header file

#ifndef	__24DSI64C200K_H__
#define	__24DSI64C200K_H__

#include "gsc_common.h"
#include "gsc_pci9056.h"



// macros *********************************************************************

#define	DSI64C200K_BASE_NAME				"24dsi64c200k"

// IOCTL command codes

#define	DSI64C200K_IOCTL_REG_READ			OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	DSI64C200K_IOCTL_REG_WRITE			OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	DSI64C200K_IOCTL_REG_MOD			OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	DSI64C200K_IOCTL_QUERY				OS_IOCTL_RW( 3,  4, s32)
#define	DSI64C200K_IOCTL_INITIALIZE			OS_IOCTL   ( 4)
#define	DSI64C200K_IOCTL_AUTO_CALIBRATE		OS_IOCTL   ( 5)
#define	DSI64C200K_IOCTL_AUTO_CAL_STS		OS_IOCTL_R ( 6,  4, s32)
#define	DSI64C200K_IOCTL_AI_BUF_CLEAR		OS_IOCTL   ( 7)
#define	DSI64C200K_IOCTL_AI_BUF_ENABLE		OS_IOCTL_RW( 8,  4, s32)
#define	DSI64C200K_IOCTL_AI_BUF_FILL_LVL	OS_IOCTL_R ( 9,  4, s32)
#define	DSI64C200K_IOCTL_AI_BUF_OVERFLOW	OS_IOCTL_RW(10,  4, s32)
#define	DSI64C200K_IOCTL_AI_BUF_THR_STS		OS_IOCTL_R (11,  4, s32)
#define	DSI64C200K_IOCTL_AI_BUF_THRESH		OS_IOCTL_RW(12,  4, s32)
#define	DSI64C200K_IOCTL_AI_BUF_UNDERFLOW	OS_IOCTL_RW(13,  4, s32)
#define	DSI64C200K_IOCTL_AI_FILTER			OS_IOCTL_RW(14,  4, s32)
#define	DSI64C200K_IOCTL_AI_MODE			OS_IOCTL_RW(15,  4, s32)
#define	DSI64C200K_IOCTL_AUX_CLOCK			OS_IOCTL_RW(16,  4, s32)
#define	DSI64C200K_IOCTL_AUX_SYNC			OS_IOCTL_RW(17,  4, s32)
#define	DSI64C200K_IOCTL_BURST_ENABLE		OS_IOCTL_RW(18,  4, s32)
#define	DSI64C200K_IOCTL_BURST_RATE_DIV		OS_IOCTL_RW(19,  4, s32)
#define	DSI64C200K_IOCTL_BURST_SIZE			OS_IOCTL_RW(20,  4, s32)
#define	DSI64C200K_IOCTL_BURST_TIMER		OS_IOCTL_RW(21,  4, s32)
#define	DSI64C200K_IOCTL_BURST_TRIGGER		OS_IOCTL   (22)
#define	DSI64C200K_IOCTL_CHAN_GRP_ACTIVE	OS_IOCTL_RW(23,  4, s32)
#define	DSI64C200K_IOCTL_CHANNELS_READY		OS_IOCTL_RW(24,  4, s32)
#define	DSI64C200K_IOCTL_CLK_SRC			OS_IOCTL_RW(25,  4, s32)
#define	DSI64C200K_IOCTL_CONTROL_MODE		OS_IOCTL_RW(26,  4, s32)
#define	DSI64C200K_IOCTL_DATA_FORMAT		OS_IOCTL_RW(27,  4, s32)
#define	DSI64C200K_IOCTL_DATA_WIDTH			OS_IOCTL_RW(28,  4, s32)
#define	DSI64C200K_IOCTL_DIO_DIR_OUT		OS_IOCTL_RW(29,  4, s32)
#define	DSI64C200K_IOCTL_DIO_READ			OS_IOCTL_R (30,  4, s32)
#define	DSI64C200K_IOCTL_DIO_WRITE			OS_IOCTL_RW(31,  4, s32)
#define	DSI64C200K_IOCTL_EXT_CLK_SRC		OS_IOCTL_RW(32,  4, s32)
#define	DSI64C200K_IOCTL_FGEN_DIV			OS_IOCTL_RW(33,  4, s32)
#define	DSI64C200K_IOCTL_INIT_ADCS			OS_IOCTL   (34)
#define	DSI64C200K_IOCTL_IRQ_SEL			OS_IOCTL_RW(35,  4, s32)
#define	DSI64C200K_IOCTL_MCLK_DIV			OS_IOCTL_RW(36,  4, s32)
#define	DSI64C200K_IOCTL_NREF				OS_IOCTL_RW(37,  4, s32)
#define	DSI64C200K_IOCTL_NVCO				OS_IOCTL_RW(38,  4, s32)
#define	DSI64C200K_IOCTL_OVER_SAMPLE		OS_IOCTL_RW(39,  4, s32)
#define	DSI64C200K_IOCTL_RX_IO_ABORT		OS_IOCTL_R (40,  4, s32)
#define	DSI64C200K_IOCTL_RX_IO_MODE			OS_IOCTL_RW(41,  4, s32)
#define	DSI64C200K_IOCTL_RX_IO_OVERFLOW		OS_IOCTL_RW(42,  4, s32)
#define	DSI64C200K_IOCTL_RX_IO_TIMEOUT		OS_IOCTL_RW(43,  4, s32)
#define	DSI64C200K_IOCTL_RX_IO_UNDERFLOW	OS_IOCTL_RW(44,  4, s32)
#define	DSI64C200K_IOCTL_SW_SYNC			OS_IOCTL   (45)
#define	DSI64C200K_IOCTL_SW_SYNC_MODE		OS_IOCTL_RW(46,  4, s32)
#define	DSI64C200K_IOCTL_SYNC_SRC			OS_IOCTL_RW(47,  4, s32)
#define	DSI64C200K_IOCTL_WAIT_CANCEL		OS_IOCTL_RW(48, 28, gsc_wait_t)
#define	DSI64C200K_IOCTL_WAIT_EVENT			OS_IOCTL_RW(49, 28, gsc_wait_t)
#define	DSI64C200K_IOCTL_WAIT_STATUS		OS_IOCTL_RW(50, 28, gsc_wait_t)
#define	DSI64C200K_IOCTL_XCVR_TYPE			OS_IOCTL_RW(51,  4, s32)



//*****************************************************************************
// DSI64C200K_IOCTL_REG_READ
// DSI64C200K_IOCTL_REG_WRITE
// DSI64C200K_IOCTL_REG_MOD
//
#define	DSI64C200K_REG_ENCODE(s,o)			GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*

#define	DSI64C200K_GSC_BCTLR				DSI64C200K_REG_ENCODE(4,0x00)// Board Control Register
#define	DSI64C200K_GSC_RCR					DSI64C200K_REG_ENCODE(4,0x04)// Rate Control Register
#define	DSI64C200K_GSC_DIOPR				DSI64C200K_REG_ENCODE(4,0x08)// Digital I/O Port Register
#define	DSI64C200K_GSC_AICR					DSI64C200K_REG_ENCODE(4,0x0C)// Analog Input Configuration Register
#define	DSI64C200K_GSC_BBSR					DSI64C200K_REG_ENCODE(4,0x18)// Burst Block Size Register
#define	DSI64C200K_GSC_BTTR					DSI64C200K_REG_ENCODE(4,0x1C)// Burst Trigger Timer Register
#define	DSI64C200K_GSC_BUFCR				DSI64C200K_REG_ENCODE(4,0x20)// Buffer Control Register
#define	DSI64C200K_GSC_BCFGR				DSI64C200K_REG_ENCODE(4,0x24)// Board Configuration Register
#define	DSI64C200K_GSC_BUFSR				DSI64C200K_REG_ENCODE(4,0x28)// Buffer Size Register
#define	DSI64C200K_GSC_AVR					DSI64C200K_REG_ENCODE(4,0x2C)// Auto-Cal Values Register
#define	DSI64C200K_GSC_IDBR					DSI64C200K_REG_ENCODE(4,0x30)// Input Data Buffer Register
#define	DSI64C200K_GSC_ASIOCR				DSI64C200K_REG_ENCODE(4,0x34)// Auxiliary SYNC I/O Control Register

//*****************************************************************************
// DSI64C200K_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	DSI64C200K_QUERY_AUTO_CAL_MS,	// Max auto-cal period in ms.
	DSI64C200K_QUERY_CHANNEL_MAX,	// Maximum number of channels supported.
	DSI64C200K_QUERY_CHANNEL_QTY,	// The number of A/D channels. (BCFGR D16-D17)
	DSI64C200K_QUERY_COUNT,			// Number of query options.
	DSI64C200K_QUERY_DEVICE_TYPE,	// Value from gsc_dev_type_t
	DSI64C200K_QUERY_FGEN_MAX,		// Rate Generator maximum output rate.
	DSI64C200K_QUERY_FGEN_MIN,		// Rate Generator minimum output rate.
	DSI64C200K_QUERY_FIFO_SIZE,		// FIFO depth in 32-bit samples
	DSI64C200K_QUERY_FILTER_FREQ,	// Image Filter Frequency (BCFGR D20-D21)
	DSI64C200K_QUERY_FREF_DEFAULT,	// The default Fref value for the device.
	DSI64C200K_QUERY_FSAMP_MAX,		// The maximum sample rate.
	DSI64C200K_QUERY_FSAMP_MIN,		// The minimum sample rate.
	DSI64C200K_QUERY_FW_REV,		// Firmware Revision: 0xXXXXXX (BCFGR D0-D11)
	DSI64C200K_QUERY_INIT_ADC_MS,	// Max ADC initialize period in ms.
	DSI64C200K_QUERY_INIT_MS,		// Max initialize period in ms.
	DSI64C200K_QUERY_MASTER_CLOCK,	// The frequency of the master clock (BCFGR D22-D23)
	DSI64C200K_QUERY_MCLK_MAX,		// The maximum Mclk rate.
	DSI64C200K_QUERY_MCLK_MIN,		// The minimum Mclk rate.
	DSI64C200K_QUERY_NREF_MAX,		// PLL: Maximum rate generator Nref value.
	DSI64C200K_QUERY_NREF_MIN,		// PLL: Minimum rate generator Nref value.
	DSI64C200K_QUERY_NREF_OPT_MAX,	// PLL: Maximum optimum rate generator Nref value.
	DSI64C200K_QUERY_NREF_OPT_MIN,	// PLL: Minimum optimum rate generator Nref value.
	DSI64C200K_QUERY_NVCO_MAX,		// PLL: Maximum rate generator Nvco value.
	DSI64C200K_QUERY_NVCO_MIN,		// PLL: Minimum rate generator Nvco value.
	DSI64C200K_QUERY_NVCO_OPT_MAX,	// PLL: Maximum optimum rate generator Nvco value.
	DSI64C200K_QUERY_NVCO_OPT_MIN,	// PLL: Minimum optimum rate generator Nvco value.
	DSI64C200K_QUERY_V_RANGE,		// +-10 (BCFGR D18-D19)

	DSI64C200K_QUERY_LAST			// This is always last. Don't query this.
} dsi64c200k_query_t;

#define	DSI64C200K_IOCTL_QUERY_ERROR		(-1)	// Invalid/unknown query.

// DSI64C200K_QUERY_V_RANGE values returned
#define	DSI64C200K_QUERY_V_RANGE_10			0	// +- 10

// DSI64C200K_QUERY_FILTER_FREQ values returned
// 900,000 = 900K
// -1 = option value not recognized

// DSI64C200K_QUERY_FREF_DEFAULT values returned
// 32,768,000 = 32,768,000 Hz

// DSI64C200K_QUERY_MASTER_CLOCK values returned
// 49,152,000 = 49,152,000 Hz

//*****************************************************************************
// DSI64C200K_IOCTL_INITIALIZE				BCTLR D15
//
//	Parameter:	None

//*****************************************************************************
// DSI64C200K_IOCTL_AUTO_CALIBRATE			BCTLR D7
//
//	Parameter:	None

//*****************************************************************************
// DSI64C200K_IOCTL_AUTO_CAL_STS			BCTLR D7, D12
//
//	Parameter:	s32
//		The service returns one of the follwing options.

#define	DSI64C200K_AUTO_CAL_STS_ACTIVE		0
#define	DSI64C200K_AUTO_CAL_STS_FAIL		1
#define	DSI64C200K_AUTO_CAL_STS_PASS		2

//*****************************************************************************
// DSI64C200K_IOCTL_AI_BUF_CLEAR			BUFCR D20
//
//	Parameter:	None

//*****************************************************************************
// DSI64C200K_IOCTL_AI_BUF_ENABLE			BUFCR D19
//
//	Parameter:	s32
//		Pass in any valid option below, or -1 to read the current setting.

#define	DSI64C200K_AI_BUF_ENABLE_NO			0
#define	DSI64C200K_AI_BUF_ENABLE_YES		1

//*****************************************************************************
// DSI64C200K_IOCTL_AI_BUF_FILL_LVL			BUFSR D0-D18
//
//	Parameter:	s32
//		Values returned are from 0 to 0x40000 (256K).

//*****************************************************************************
// DSI64C200K_IOCTL_AI_BUF_OVERFLOW			BUFCR D24
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_AI_BUF_OVERFLOW_CLEAR	0
#define	DSI64C200K_AI_BUF_OVERFLOW_TEST		(-1)

// The following are the set of returned values.
#define	DSI64C200K_AI_BUF_OVERFLOW_NO		0
#define	DSI64C200K_AI_BUF_OVERFLOW_YES		1

//*****************************************************************************
// DSI64C200K_IOCTL_AI_BUF_THR_STS			BCTLR D14
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_AI_BUF_THR_STS_IDLE		0
#define	DSI64C200K_AI_BUF_THR_STS_ACTIVE	1

//*****************************************************************************
// DSI64C200K_IOCTL_AI_BUF_THRESH			BUFCR D0-D18
//
//	Parameter:	s32
//		Pass in any valid from 0 to 0x40000, or -1 to read the current setting.

//*****************************************************************************
// DSI64C200K_IOCTL_AI_BUF_UNDERFLOW		BUFCR D25
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_AI_BUF_UNDERFLOW_CLEAR	0
#define	DSI64C200K_AI_BUF_UNDERFLOW_TEST	(-1)

// The following are the set of returned values.
#define	DSI64C200K_AI_BUF_UNDERFLOW_NO		0
#define	DSI64C200K_AI_BUF_UNDERFLOW_YES		1

//*****************************************************************************
// DSI64C200K_IOCTL_AI_FILTER				AICR D23
//
//	Parameter:	s32
//		Pass in any valid option below, or -1 to read the current setting.

#define	DSI64C200K_AI_FILTER_WIDEBAND		0
#define	DSI64C200K_AI_FILTER_LOW_LATENCY	1

//*****************************************************************************
// DSI64C200K_IOCTL_AI_MODE					BCTLR D0-D1
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_AI_MODE_DIFF				0	// Differential
#define	DSI64C200K_AI_MODE_ZERO				2	// Zero test
#define	DSI64C200K_AI_MODE_VREF				3	// Vref test

//*****************************************************************************
// DSI64C200K_IOCTL_AUX_CLOCK				ASIOCR D0-D1
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_AUX_CLOCK_INACTIVE		0
#define	DSI64C200K_AUX_CLOCK_INPUT			1
#define	DSI64C200K_AUX_CLOCK_OUTPUT			2

//*****************************************************************************
// DSI64C200K_IOCTL_AUX_SYNC				ASIOCR D2-D3
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_AUX_SYNC_INACTIVE		0
#define	DSI64C200K_AUX_SYNC_INPUT			1
#define	DSI64C200K_AUX_SYNC_OUTPUT			2

//*****************************************************************************
// DSI64C200K_IOCTL_BURST_ENABLE			BCTLR D22
//
//	Parameter:	s32
//		Pass in any valid option below, or -1 to read the current setting.

#define	DSI64C200K_BURST_ENABLE_NO			0
#define	DSI64C200K_BURST_ENABLE_YES			1

//*****************************************************************************
// DSI64C200K_IOCTL_BURST_RATE_DIV			BTTR D0-D23
//
//	Parameter:	s32
//		Pass in any valid from 0 to 0xFFFFFF, or -1 to read the current setting.

//*****************************************************************************
// DSI64C200K_IOCTL_BURST_SIZE				BBSR D0-D23
//
//	Parameter:	s32
//		Pass in any valid from 0 to 0xFFFFFF, or -1 to read the current setting.

//*****************************************************************************
// DSI64C200K_IOCTL_BURST_TIMER				BCTLR D16
//
//	Parameter:	s32
//		Pass in any valid option below, or -1 to read the current setting.

#define	DSI64C200K_BURST_TIMER_DISABLE		0
#define	DSI64C200K_BURST_TIMER_ENABLE		1

//*****************************************************************************
// DSI64C200K_IOCTL_BURST_TRIGGER			BCTLR D23
//
//	Parameter:	None

//*****************************************************************************
// DSI64C200K_IOCTL_CHAN_GRP_ACTIVE			AICR D0-D7
//
//	Parameter:	s32
//		Pass in any valid from 0 to 0xFF, or -1 to read the current setting.

//*****************************************************************************
// DSI64C200K_IOCTL_CHANNELS_READY			BCTLR D13
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.
#define	DSI64C200K_CHANNELS_READY_WAIT		0
#define	DSI64C200K_CHANNELS_READY_TEST		(-1)

// These are the values returned.
#define	DSI64C200K_CHANNELS_READY_NO		0
#define	DSI64C200K_CHANNELS_READY_YES		1

//*****************************************************************************
// DSI64C200K_IOCTL_CLK_SRC					AICR D20-D21
//
//	Parameter:	s32
//		Pass in any valid option below, or -1 to read the current setting.

#define	DSI64C200K_CLK_SRC_RATE_GEN			0
#define	DSI64C200K_CLK_SRC_EXT_FGEN			1
#define	DSI64C200K_CLK_SRC_EXT_MCLK			2

//*****************************************************************************
// DSI64C200K_IOCTL_CONTROL_MODE			BCTLR D5
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_CONTROL_MODE_TARGET		0
#define	DSI64C200K_CONTROL_MODE_INITIATOR	1

//*****************************************************************************
// DSI64C200K_IOCTL_DATA_FORMAT				BCTLR D4
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_DATA_FORMAT_2S_COMP		0	// Twos Compliment
#define	DSI64C200K_DATA_FORMAT_OFF_BIN		1	// Offset Binary

//*****************************************************************************
// DSI64C200K_IOCTL_DATA_WIDTH				BUFCR D21-D22
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_DATA_WIDTH_16			0
#define	DSI64C200K_DATA_WIDTH_18			1
#define	DSI64C200K_DATA_WIDTH_20			2
#define	DSI64C200K_DATA_WIDTH_24			3

//*****************************************************************************
// DSI64C200K_IOCTL_DIO_DIR_OUT				DIOPR D8-D11
//
//	Parameter:	s32
//		Pass in any value from 0 to 0xF, or -1 to read the current setting.

//*****************************************************************************
// DSI64C200K_IOCTL_DIO_READ				DIOPR D0-D3
//
//	Parameter:	s32
//		Values returned are from 0 to 0xF.

//*****************************************************************************
// DSI64C200K_IOCTL_DIO_WRITE				DIOPR D0-D3
//
//	Parameter:	s32
//		Pass in any valid from 0 to 0xF, or -1 to read the current setting.

//*****************************************************************************
// DSI64C200K_IOCTL_EXT_CLK_SRC				BCTLR D18
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_EXT_CLK_SRC_MCLK			0
#define	DSI64C200K_EXT_CLK_SRC_GEN			1

//*****************************************************************************
// DSI64C200K_IOCTL_FGEN_DIV				AICR D8-D11
//
//	Parameter:	s32
//		Pass in any valid option below, or -1 to read the current setting.

#define	DSI64C200K_FGEN_DIV_1				0
#define	DSI64C200K_FGEN_DIV_2				1
#define	DSI64C200K_FGEN_DIV_4				2
#define	DSI64C200K_FGEN_DIV_8				3
#define	DSI64C200K_FGEN_DIV_16				4

//*****************************************************************************
// DSI64C200K_IOCTL_INIT_ADCS				BCTLR D19
//
//	Parameter:	None

//*****************************************************************************
// DSI64C200K_IOCTL_IRQ_SEL					BCTLR D8-D10
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_IRQ_INIT_DONE			0
#define	DSI64C200K_IRQ_AUTO_CAL_DONE		1
#define	DSI64C200K_IRQ_CHAN_READY_L2H		2
#define	DSI64C200K_IRQ_AI_BUF_THR_L2H		3
#define	DSI64C200K_IRQ_AI_BUF_THR_H2L		4
#define	DSI64C200K_IRQ_AI_BURST_DONE		5
#define	DSI64C200K_IRQ_CHAN_READY_H2L		6

//*****************************************************************************
// DSI64C200K_IOCTL_MCLK_DIV				AICR D12-D15
//
//	Parameter:	s32
//		Pass in any valid option below, or -1 to read the current setting.

#define	DSI64C200K_MCLK_DIV_32_ECO			0	// lowest bandwidth, lowest power
#define	DSI64C200K_MCLK_DIV_8_MEDIAN		1	// internediate bandwidth and power
#define	DSI64C200K_MCLK_DIV_4_FAST			2	// highest bandwidth, maximum power

//*****************************************************************************
// DSI64C200K_IOCTL_NREF					RCR D16-D27
//	Parameter:	s32
//		Pass in any value from 20 to 300, or -1 to read the current setting.

//*****************************************************************************
// DSI64C200K_IOCTL_NVCO					RCR D0-D11
//
//	Parameter:	s32
//		Pass in any value from 20 tp 300, or -1 to read the current setting.

//*****************************************************************************
// DSI64C200K_IOCTL_OVER_SAMPLE				AICR D16-D19
//
//	Parameter:	s32
//		Pass in any valid option below, or -1 to read the current setting.

#define	DSI64C200K_OVER_SAMPLE_32			0
#define	DSI64C200K_OVER_SAMPLE_64			1
#define	DSI64C200K_OVER_SAMPLE_128			2
#define	DSI64C200K_OVER_SAMPLE_1024			3

//*****************************************************************************
// DSI64C200K_IOCTL_SW_SYNC					BCTLR D6
//
//	Parameter:	None

//*****************************************************************************
// DSI64C200K_IOCTL_SW_SYNC_MODE			BCTLR D17
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_SW_SYNC_MODE_SYNC		0	// Perform a Sync operation
#define	DSI64C200K_SW_SYNC_MODE_CLR_BUF		1	// Clear the input buffer/

//*****************************************************************************
// DSI64C200K_IOCTL_SYNC_SRC				AICR D22
//
//	Parameter:	s32
//		Pass in any valid option below, or -1 to read the current setting.

#define	DSI64C200K_SYNC_SRC_TIMER_BCR		0
#define	DSI64C200K_SYNC_SRC_EXT_BCR			1

//*****************************************************************************
// DSI64C200K_IOCTL_RX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.

#define	DSI64C200K_IO_ABORT_NO				0
#define	DSI64C200K_IO_ABORT_YES				1

//*****************************************************************************
// DSI64C200K_IOCTL_RX_IO_MODE
//
//	Parameter:	s32
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.

#define	DSI64C200K_IO_MODE_DEFAULT			GSC_IO_MODE_PIO
// GSC_IO_MODE_PIO
// GSC_IO_MODE_BMDMA
// GSC_IO_MODE_DMDMA

//*****************************************************************************
// DSI64C200K_IOCTL_RX_IO_OVERFLOW
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_IO_OVERFLOW_DEFAULT		DSI64C200K_IO_OVERFLOW_CHECK
#define	DSI64C200K_IO_OVERFLOW_IGNORE		0
#define	DSI64C200K_IO_OVERFLOW_CHECK		1

//*****************************************************************************
// DSI64C200K_IOCTL_RX_IO_TIMEOUT			(in seconds)
//
//	Parameter:	s32
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.

#define	DSI64C200K_IO_TIMEOUT_DEFAULT		10
#define	DSI64C200K_IO_TIMEOUT_NO_SLEEP		0		// Don't sleep to wait for data.
#define	DSI64C200K_IO_TIMEOUT_MIN			0
#define	DSI64C200K_IO_TIMEOUT_MAX			GSC_IO_TIMEOUT_MAX
#define	DSI64C200K_IO_TIMEOUT_INFINITE		GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// DSI64C200K_IOCTL_RX_IO_UNDERFLOW
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_IO_UNDERFLOW_DEFAULT		DSI64C200K_IO_UNDERFLOW_CHECK
#define	DSI64C200K_IO_UNDERFLOW_IGNORE		0
#define	DSI64C200K_IO_UNDERFLOW_CHECK		1

//*****************************************************************************
// DSI64C200K_IOCTL_WAIT_EVENT				all fields must be valid
// DSI64C200K_IOCTL_WAIT_CANCEL				fields need not be valid
// DSI64C200K_IOCTL_WAIT_STATUS				fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	DSI64C200K_WAIT_GSC_INIT_DONE		0x0001
#define	DSI64C200K_WAIT_GSC_AUTO_CAL_DONE	0x0002
#define	DSI64C200K_WAIT_GSC_CHAN_READY_L2H	0x0004
#define	DSI64C200K_WAIT_GSC_AI_BUF_THR_L2H	0x0008
#define	DSI64C200K_WAIT_GSC_AI_BUF_THR_H2L	0x0010
#define	DSI64C200K_WAIT_GSC_AI_BURST_DONE	0x0020
#define	DSI64C200K_WAIT_GSC_CHAN_READY_H2L	0x0040
#define	DSI64C200K_WAIT_GSC_ALL				0x007F
// gsc_wait_t.alt flags
#define	DSI64C200K_WAIT_ALT_ALL				0x0000
// gsc_wait_t.io - see gsc_common.h
#define	DSI64C200K_WAIT_IO_RX_ABORT			0x0001
#define	DSI64C200K_WAIT_IO_RX_DONE			0x0002
#define	DSI64C200K_WAIT_IO_RX_ERROR			0x0004
#define	DSI64C200K_WAIT_IO_RX_TIMEOUT		0x0008
#define	DSI64C200K_WAIT_IO_ALL				0x000F

//*****************************************************************************
// DSI64C200K_IOCTL_XCVR_TYPE				BCTLR D21
//
//	Parameter:	s32
//		Pass in any of the below options, or -1 to read the current setting.

#define	DSI64C200K_XCVR_TYPE_LVDS			0
#define	DSI64C200K_XCVR_TYPE_TTL			1



#endif
