// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI64C200K/24DSI64C200K_linux_1.x_gsc_dn/include/24dsi64c200k_utils.h $
// $Rev: 52114 $
// $Date: 2022-12-01 11:04:21 -0600 (Thu, 01 Dec 2022) $

// 24DSI64C200K: Utilities: header file

#ifndef	__24DSI64C200K_UTILS_H__
#define	__24DSI64C200K_UTILS_H__

#include "24dsi64c200k_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	dsi64c200k_close_util			(int fd, int index, int verbose);
int	dsi64c200k_init_util			(int verbose);
int dsi64c200k_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	dsi64c200k_open_util			(int device, int share, int index, int verbose, int* fd);
int	dsi64c200k_read_util			(int fd, int index, int verbose, void* dst, size_t bytes);

// IOCTL utility services

int	dsi64c200k_ai_buf_clear			(int fd, int index, int verbose);								// DSI64C200K_IOCTL_AI_BUF_CLEAR
int	dsi64c200k_ai_buf_enable		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_AI_BUF_ENABLE
int	dsi64c200k_ai_buf_fill_lvl		(int fd, int index, int verbose, s32* get);						// DSI64C200K_IOCTL_AI_BUF_FILL_LVL
int	dsi64c200k_ai_buf_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_AI_BUF_OVERFLOW
int	dsi64c200k_ai_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// DSI64C200K_IOCTL_AI_BUF_THR_STS
int	dsi64c200k_ai_buf_thresh		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_AI_BUF_THRESH
int	dsi64c200k_ai_buf_underflow		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_AI_BUF_UNDERFLOW
int	dsi64c200k_ai_filter			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_AI_FILTER
int	dsi64c200k_ai_mode				(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_AI_MODE
int	dsi64c200k_auto_cal_sts			(int fd, int index, int verbose, s32* get);						// DSI64C200K_IOCTL_AUTO_CAL_STS
int	dsi64c200k_auto_calibrate		(int fd, int index, int verbose);								// DSI64C200K_IOCTL_AUTO_CALIBRATE
int dsi64c200k_aux_clock			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_AUX_CLOCK
int dsi64c200k_aux_sync				(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_AUX_SYNC
int	dsi64c200k_burst_enable			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_BURST_ENABLE
int	dsi64c200k_burst_rate_div		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_BURST_RATE_DIV
int	dsi64c200k_burst_size			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_BURST_SIZE
int	dsi64c200k_burst_timer			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_BURST_TIMER
int	dsi64c200k_burst_trigger		(int fd, int index, int verbose);								// DSI64C200K_IOCTL_BURST_TRIGGER
int	dsi64c200k_clk_src				(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_CLK_SRC
int dsi64c200k_chan_grp_active		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_CHAN_GRP_ACTIVE
int	dsi64c200k_channels_ready		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_CHANNELS_READY
int	dsi64c200k_control_mode			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_CONTROL_MODE
int	dsi64c200k_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_DATA_FORMAT
int	dsi64c200k_data_width			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_DATA_WIDTH
int	dsi64c200k_dio_dir_out			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_DIO_DIR_OUT
int	dsi64c200k_dio_read				(int fd, int index, int verbose, s32* get);						// DSI64C200K_IOCTL_DIO_READ
int	dsi64c200k_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_DIO_WRITE
int	dsi64c200k_ext_clk_src			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_EXT_CLK_SRC
int dsi64c200k_fgen_div				(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_FGEN_DIV
int dsi64c200k_init_adcs			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_INIT_ADCS
int	dsi64c200k_initialize			(int fd, int index, int verbose);								// DSI64C200K_IOCTL_INITIALIZE
int	dsi64c200k_irq_sel				(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_IRQ_SEL
int dsi64c200k_mclk_div				(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_MCLK_DIV
int	dsi64c200k_nref					(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_NREF
int	dsi64c200k_nvco					(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_NVCO
int	dsi64c200k_over_sample			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_OVER_SAMPLE
int	dsi64c200k_query				(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_QUERY
int	dsi64c200k_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// DSI64C200K_IOCTL_REG_MOD
int	dsi64c200k_reg_read				(int fd, int index, int verbose, u32 reg, u32* value);			// DSI64C200K_IOCTL_REG_READ
int	dsi64c200k_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// DSI64C200K_IOCTL_REG_WRITE
int	dsi64c200k_rx_io_abort			(int fd, int index, int verbose, s32* get);						// DSI64C200K_IOCTL_RX_IO_ABORT
int	dsi64c200k_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_RX_IO_MODE
int	dsi64c200k_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_RX_IO_OVERFLOW
int	dsi64c200k_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_RX_IO_TIMEOUT
int	dsi64c200k_rx_io_underflow		(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_RX_IO_UNDERFLOW
int	dsi64c200k_sw_sync				(int fd, int index, int verbose);								// DSI64C200K_IOCTL_SW_SYNC
int	dsi64c200k_sw_sync_mode			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_SW_SYNC_MODE
int dsi64c200k_sync_src				(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_SYNC_SRC
int	dsi64c200k_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// DSI64C200K_IOCTL_WAIT_CANCEL
int	dsi64c200k_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// DSI64C200K_IOCTL_WAIT_EVENT
int	dsi64c200k_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// DSI64C200K_IOCTL_WAIT_STATUS
int	dsi64c200k_xcvr_type			(int fd, int index, int verbose, s32 set, s32* get);			// DSI64C200K_IOCTL_XCVR_TYPE

// Auxiliary utility services

int	dsi64c200k_channels_ready_wait	(int fd, int index, int verbose, s32* get);
int	dsi64c200k_config_ai			(int fd, int index, int verbose, s32 fref, s32 fsamp);
int dsi64c200k_fsamp_ai_compute		(int fd, int index, int verbose, s32 fref, s32 fsamp, int optimal, s32* nvco, s32* nref, s32* fgen_div, s32* mclk_div, s32* over_sample, double* rate);
int	dsi64c200k_fsamp_ai_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int	dsi64c200k_fsamp_ai_report_all	(int fd, int index, int verbose, s32* fsamp);
int	dsi64c200k_id_device			(int fd, int index, int verbose);

int	dsi64c200k_count_boards			(int verbose, s32* get);
int	dsi64c200k_id_driver			(void);
int	dsi64c200k_reg_list				(int fd, int detail);

const gsc_reg_def_t*				dsi64c200k_reg_get_def_id(u32 reg);
const gsc_reg_def_t*				dsi64c200k_reg_get_def_index(int index);
const char*							dsi64c200k_reg_get_desc(u32 reg);
const char*							dsi64c200k_reg_get_name(u32 reg);



#endif
