// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI64C200K/24DSI64C200K_linux_1.x_gsc_dn/samples/irq/main.h $
// $Rev: 52646 $
// $Date: 2023-03-21 09:53:43 -0500 (Tue, 21 Mar 2023) $

// 24DSI64C200K: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdlib.h>

#include "24dsi64c200k_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)				(sizeof((a)) / sizeof((a)[0]))

#define	STATUS_NOT_IMPLEMENTED		(-2)
#define	STATUS_NOT_SUPPORTED		(-1)
#define	STATUS_SUPPORTED			(0)



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of boards detected.
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

} args_t;



// prototypes *****************************************************************

int	gsc_ai_burst_done_irq_test(int fd, int supported);
int	gsc_auto_cal_done_irq_test(int fd, int supported);
int	gsc_chan_ready_h2l_irq_test(int fd, int supported);
int	gsc_chan_ready_l2h_irq_test(int fd, int supported);
int	gsc_init_done_irq_test(int fd, int supported);
int	gsc_thresh_status_h2l_irq_test(int fd, int supported);
int	gsc_thresh_status_l2h_irq_test(int fd, int supported);

int	main_dma_irq_test(int fd, int supported);
int	main_gsc_irq_test(int fd, int supported);
int	main_pci_irq_test(int fd, int supported);

int	perform_tests(const args_t* args);



#endif
